%{
#include <stdio.h>
#include <ctype.h>
#define emit fprintf
%}


%start programa
%token CONST VAR PROCEDIMENTO
%token INIBLOCO FIMBLOCO
%token IF THEN WHILE DO ODD CALL
%token IDENT NUMERO LIBRARY

%left '+' '-'
%left '*' '/'
%left MENOSUN

%%

programa : {emit(yyout,"DOSSEG\n.MODEL SMALL\n.STACK 10000\n");}
           LIBRARY  ';'
	   {
	     emit(yyout,"extrn _iolibrary:word\n");
	     emit(yyout,"extrn _get:near\nextrn _put:near\n.DATA\n");
	     acresc_tab_simb();
	   }
           bloco '.'
	   {emit(yyout,"END _PROG_PRINCIPAL\n");}
         | {emit(yyout,"DOSSEG\n.MODEL SMALL\n.STACK 10000\n.DATA\n");}
           bloco '.'
	   {emit(yyout,"END _PROG_PRINCIPAL\n");}
         ;

bloco    : CONST defconst VAR {desl=0;}
	   defvar {emit(yyout,".CODE\n");}
           defproc {emit(yyout,"_PROG_PRINCIPAL PROC NEAR\n");}
           stmt
           {emit(yyout,"\tmov ah,4Ch\n\tint 21h\n\tret\n_PROG_PRINCIPAL ENDP\n");}
         | CONST defconst  {emit(yyout,".CODE\n");}
           defproc {emit(yyout,"_PROG_PRINCIPAL PROC NEAR\n");}
           stmt
           {emit(yyout,"\tmov ah,4Ch\n\tint 21h\n\tret\n_PROG_PRINCIPAL ENDP\n");}
         | VAR {desl=0;}
           defvar {emit(yyout,".CODE\n");}
           defproc {emit(yyout,"_PROG_PRINCIPAL PROC NEAR\n");}
           stmt
           {emit(yyout,"\tmov ah,4Ch\n\tint 21h\n\tret\n_PROG_PRINCIPAL ENDP\n");}
         | {emit(yyout,".CODE\n");}
           defproc
           {emit(yyout,"_PROG_PRINCIPAL PROC NEAR\n");}
           stmt
           {emit(yyout,"\tmov ah,4Ch\n\tint 21h\n\tret\n_PROG_PRINCIPAL ENDP\n");}
         ;

defconst : /* {decl=1;} nao pude usar esta acao aqui porque gerava mensagem */
	   IDENT        /* de regra nunca reduzida, coloquei no Lex */
           '='
	   NUMERO
	   {
             aux2=pesquisa_local(aux->nome);
	     if (aux->nref>1 && aux2) /* ha mais de uma referencia a um id */
				      /* em uma mesma declaracao           */
	       printf("Erro, lin %d: Redeclaracao da constante _%s\n",
                       numlin, aux->nome);
             else{
               if(!aux2) /* precisa ser declarada localmente */
		 aux2=insere_nodo(aux->nome);
	       poe_token(IDENT);
               poe_tipo(TIPOCONST);
               poe_nivel();
               poe_valor(yylval);
             }
            }
           ',' defconst
         | /* {decl=1;} */
           IDENT
           '='
	   NUMERO
	   {
             decl=0;
             aux2=pesquisa_local(aux->nome);
	     if (aux->nref>1 && aux2) /* ha mais de uma referencia a um id */
				      /* em uma mesma declaracao           */
	       printf("Erro, lin %d: Redeclaracao da constante _%s\n",
                       numlin, aux->nome);
             else{
               if(!aux2) /* precisa ser declarada localmente */
		 aux2=insere_nodo(aux->nome);
	       poe_token(IDENT);
               poe_tipo(TIPOCONST);
               poe_nivel();
               poe_valor(yylval);
             }
            }
          ';'
	 | error {decl=0;printf("Erro lin %d: declaracao de constante invalida.\n",numlin);} ';'
         ;

defvar   :  /* {decl=1;} */
           IDENT
	   {
            aux2=pesquisa_local(aux->nome);
	    if (aux->nref>1 && aux2) /* ha mais de uma referencia a um id */
				      /* em uma mesma declaracao           */
	      printf("Erro, lin %d: Redeclaracao da variavel _%s\n",
                      numlin, aux->nome);
            else{
              if(!aux2) /* precisa ser declarada localmente */
		 aux2=insere_nodo(aux->nome);
	      poe_token(IDENT);
              poe_tipo(TIPOVAR);
              poe_nivel();
	      if(aux2->nivel==0) /* declaracao global */
		emit(yyout,"\t_%s dw 0\n",aux->nome);
              poe_desl();
            }
           }
           ','
           defvar
         | /* {decl=1;}      */
           IDENT
	   {
            decl=0;
            aux2=pesquisa_local(aux->nome);
	    if (aux->nref>1 && aux2) /* ha mais de uma referencia a um id */
				      /* em uma mesma declaracao           */
	      printf("Erro, lin %d: Redeclaracao da variavel _%s\n",
                      numlin, aux->nome);
            else{
              if(!aux2) /* precisa ser declarada localmente */
                 aux2=insere_nodo(aux->nome);
	      poe_token(IDENT);
	      poe_tipo(TIPOVAR);
              poe_nivel();
	      if(aux2->nivel==0) /* declaracao global */
		emit(yyout,"\t_%s dw 0\n",aux->nome);
              poe_desl();
            }
           }
          ';'
	 | error {decl=0;printf("Erro lin %d: declaracao de variavel invalida.\n",numlin);} ';'
         ;

defproc  : PROCEDIMENTO {decl=1;}
           IDENT
           {
            decl=0;
	    if (aux->nref>1  && pesquisa_nivel(aux->nome))
	     /* ha mais de uma referencia a um id em um mesmo nivel  */
	      printf("Erro, lin %d: Redeclaracao do procedimento _%s\n",
                      numlin, aux->nome);
            else{
	      poe_tipo(TIPOPROC);
              ++nivel;
              poe_nivel();
	      strcpy(proc_corr[nivel]=malloc(strlen(aux->nome)+1),
		     strupr(aux->nome));
	      strlwr(aux->nome);
	      emit(yyout,"_%s PROC NEAR\n",proc_corr[nivel]);
	      emit(yyout,"\tpush bp\n\tmov bp,sp\n");
            }
           }
           ';'
           blocoproc
           ';'
           {
	     desemp_proc(); /* desaloca o procedimento
			    /* da tab. simb. apos a compilacao */
	     emit(yyout,"\tadd sp,%d\n\tret\n_%s ENDP\n",
		  desl+2,proc_corr[nivel]);
             nivel--;
           }
           defproc
         | /* sentenca vazia */
	 | error {decl=0;
		  printf("Erro lin %d: declaracao de procedimento invalida.\n",
		  numlin);} ';'
         ;


blocoproc: CONST defconst
	   VAR defvar {
			emit(yyout,"\tsub sp,%d\n",desl);
			novo_rotulo(iniproc[procnro]);
			emit(yyout,"\tjmp %s\n",iniproc[procnro++]);
		      }
	   defproc {emit(yyout,"%s:\n",iniproc[--procnro]);}
           stmt
         | CONST
	   defconst {
		      novo_rotulo(iniproc[procnro]);
		      emit(yyout,"\tjmp %s\n",iniproc[procnro++]);
		    }
	   defproc  {emit(yyout,"%s:\n",iniproc[--procnro]);}
           stmt
         | VAR {desl=0;}
	   defvar {
		    emit(yyout,"\tsub sp,%d\n",desl);
		    novo_rotulo(iniproc[procnro]);
		    emit(yyout,"\tjmp %s\n",iniproc[procnro++]);
		  }
	   defproc {emit(yyout,"%s:\n",iniproc[--procnro]);}
           stmt
	 | {
	     novo_rotulo(iniproc[procnro]);
	     emit(yyout,"\tjmp %s\n",iniproc[procnro++]);
	   }
	   defproc {emit(yyout,"%s:\n",iniproc[--procnro]);}
           stmt
         ;

stmt     : IDENT {aux2=aux;}
           ':' '='
	   expr  {
		  if(aux2->nivel==0) /* nivel do programa principal */
		    emit(yyout,"\tpop bx\n\tmov _%s,bx\n",aux2->nome);
                  else{
		    emit(yyout,"\tpop bx\n");
		    if(aux2->nivel!=nivel){ /* estao em escopos diferentes */
		      emit(yyout,"\tpush bp\n"); acessovar(aux2);
		    }
		    emit(yyout,"\tmov [bp-%d],bx\n",aux2->desl);
		    if(aux2->nivel!=nivel) /* estao em escopos diferentes */
		      emit(yyout,"\tpop bp\n");
                  }
                 }
         | CALL IDENT  {emit(yyout,"\tcall _%s\n",aux->nome);}
         | INIBLOCO stmt stmts FIMBLOCO
	 | IF   {novo_rotulo(label);}
           cond
           THEN
           stmt {emit(yyout,"%s:\n",label);}
	 | WHILE {
		  novo_rotulo(label);
		  novo_rotulo(label1);
		  emit(yyout,"%s:\n",label1);
		 }
           cond
           DO
	   stmt  {emit(yyout,"\tjmp %s\n",label1); emit(yyout,"%s:\n",label);}
         | /* sentenca vazia */
	 | error {printf("Erro lin %d: comando invalido.\n",numlin);} ';'
	 ;

stmts    : ';' stmt stmts
         | /* sentenca vazia */
	 | error {printf("Erro lin %d: comando invalido.\n",numlin);} ';'
         ;

cond     : ODD {emit(yyout,"\tpop ax\n\tand ax,1\n\tje %s\n",label);}
           expr
         | expr '='
	   expr {emit(yyout,"\tpop bx\n\tpop ax\n\tcmp ax,bx\n\tjne %s\n",label);}
         | expr '<' '>'
	   expr {emit(yyout,"\tpop bx\n\tpop ax\n\tcmp ax,bx\n\tje %s\n",label);}
         | expr '<'
	   expr {emit(yyout,"\tpop bx\n\tpop ax\n\tcmp ax,bx\n\tjge %s\n",label);}
         | expr '>'
	   expr {emit(yyout,"\tpop bx\n\tpop ax\n\tcmp ax,bx\n\tjle %s\n",label);}
         | expr '<' '='
	   expr {emit(yyout,"\tpop bx\n\tpop ax\n\tcmp ax,bx\n\tjg %s\n",label);}
         | expr '>' '='
	   expr {emit(yyout,"\tpop bx\n\tpop ax\n\tcmp ax,bx\n\tjl %s\n",label);}
	 | error {printf("Erro lin %d: condicao invalida.\n",numlin);} ';'
         ;

expr     : '+'  term terms
	 | '-'  term %prec MENOSUN {emit(yyout,"\tpop ax\n\tneg ax\n\tpush ax\n",$2);} terms
	 | term terms
	 | error {printf("Erro lin %d: expressao invalida.\n",numlin+1);} ';'
	 ;

terms    : '+'
	   term {emit(yyout,"\tpop bx\n\tpop ax\n\tadd ax,bx\n\tpush ax\n");}
	   terms
         | '-'
	   term  {emit(yyout,"\tpop bx\n\tpop ax\n\tsub ax,bx\n\tpush ax\n");}
	   terms
         | /* sentenca vazia */
	 | error {printf("Erro lin %d: expressao invalida.\n",numlin+1);} ';'
         ;

term     : factor factors
	 | error {printf("Erro lin %d: expressao invalida.\n",numlin+1);} ';'
         ;

factors  : '*'
	   factor {emit(yyout,"\tpop ax\n\tpop bx\n\tcwd\n\tmul bx\n\tpush ax\n");}
	   factors
         | '/'
	   factor {emit(yyout,"\tpop ax\n\tpop bx\n\tcwd\n\tdiv bx\n\tpush ax\n");}
	   factors
         | /* sentenca vazia */
	 | error {printf("Erro lin %d: expressao invalida.\n",numlin+1);} ';'
         ;

factor   : IDENT   {
		    if(aux->tipo==TIPOCONST) /* e uma constante */
		       emit(yyout,"\tmov ax,%d\n\tpush ax\n",aux->valor);
		    else if(aux->nivel==0) /* nivel do programa principal */
		      emit(yyout,"\tmov ax,_%s\n\tpush ax\n",aux->nome);
                    else{
		      if(aux->nivel!=nivel){ /* estao em escopos diferentes */
			emit(yyout,"\tpush bp\n"); acessovar(aux);
		      }
		      emit(yyout,"\tmov ax,[bp-%d]\n",aux->desl);
		      if(aux->nivel!=nivel) /* estao em escopos diferentes */
			emit(yyout,"\tpop bp\n");
		      emit(yyout,"\tpush ax\n");
		    }
		   }
	 | NUMERO  {emit(yyout,"\tmov ax,%d\n\tpush ax\n",yylval);}
         | '(' expr ')'
	 | error {printf("Erro lin %d: expressao invalida.\n",numlin+1);} ';'
         ;
%%

#include "LEXYY.C"


void main(int argc, char *argv[])
{
  if(argc==3){
    if((yyin=fopen(argv[1],"r"))==NULL){
      printf("Erro abrindo arquivo de entrada.\n");
      exit(1);
    }
    if((yyout=fopen(argv[2],"w"))==NULL){
      printf("Erro abrindo arquivo de saida.\n");
      exit(1);
    }
  }else{
    printf("Formato: syn <arquivo entrada> <arquivo saida>\n");
    exit(1);
  }
  if(!ini_tab_simb()){
    printf("Erro de inicializacao da tabela de simbolos.\n");
    exit(1);
  }
  if(yyparse()!=0)
    printf("\t %d erros na compilacao.\n",erros);
  desaloca_tab_simb();
}


int ini_tab_simb(void)
{
  /* inicializa a tabela de simbolos com as palavras reservadas */
  char *keywords[]=
  {
    "const", "var", "procedure", "begin", "end", "if", "then",
    "while", "do", "odd", "call", NULL
  };
  struct tab_simb *aux;
  int i;

  for(i=CONST; i<=CALL; i++){
    if((aux=insere_nodo(keywords[i-CONST]))==NULL)
      return 0;
    poe_token(i);
  }
  return 1;
}

acresc_tab_simb()
{ /* acescenta as funcoes e variavel da biblioteca */
  /* na tabela de simbolos                         */
  aux=insere_nodo("get");
  poe_tipo(TIPOPROC);
  poe_nivel();
  poe_token(IDENT);
  aux=insere_nodo("put");
  poe_tipo(TIPOPROC);
  poe_nivel();
  poe_token(IDENT);
  aux=insere_nodo("iolibrary");
  poe_tipo(TIPOPROC);
  poe_nivel();
  poe_token(IDENT);

  return 1;
}

void yyerror(char *s)
{
  /* chamada quando ha erro de sintaxe */
  erros++;
  if (erros>50){
    printf("Erro fatal: muitos erros.\n");
    exit(1);
  }
}


char *novo_rotulo(char *s1)
{ /* fornece um novo rotulo 'label' cada vez que e chamada */
  static unsigned i=0;
  char s2[6]="";
  strcpy(s1,"@");
  itoa(i++,s2,10);
  strcat(s1,s2);
  return(s1);
}


void acessovar(struct tab_simb *p)
{  /* funcao para gerar codigo para acesso de variaveis */
   /* em procedimentos englobantes.                     */
  int i;
  for(i=corr->nivel-1; i>=p->nivel && p->nivel; i--)
    emit(yyout,"\tmov ax,[bp]\n\tmov bp,ax\n");
}

